Position of window not retained from status icon
Target version:    

Affects version:    

Description

When opening in winamp interface and having the status icon plugin enabled, clicking the status icon, the window disappears, but

when clicking it again, it opens up in a different location than where it originally was.

I'm running 3.9 on Linux Mint 19.3

History

#1 - March 26, 2020 04:02 - Jay Philips

After additional testing the problem, I see the problem happens when contract and collapse the windows and it gets resolved when you restart

audacious.

https://youtu.be/JDB0LQiLQ-Q

I tested this in Kubuntu, Lubuntu, and Xubuntu 20.04, so its not a window manager issue.

#2 - March 26, 2020 04:42 - Öyvind Sæther

I can confirm that this happens with audacious 3.10.1 on Fedora 32 using Xfwm git. BUT it does not always happen.

1) Start Audacious in "winamp" mode

2) Move it around

3) Click and re-click status icon

4) It's fine, where it should be.

HOWEVER,

1) Click the top of the Audacious winamp window to make it a small narrow bar

2) Click the status icon to hide it and once more to get it back

3) Audacious opens the player window CENTERED on the "primary" monitor - not where it was.

4) Audacious will keep on opening the window in the center of the primary screen when hiding and re-showing it using the toolbar status icon until the

application is quit.

5) Audacious will be fine and behave as it should if you exit it and start it again - unless you make the main window a narrow bar again as in 1)

#3 - March 26, 2020 05:06 - Öyvind Sæther

- File bugtrigger.jpg added

This bug appears to be present under any window manager - xfwm4, kwin and fluxbox. Did not test more since it seems apparent that it is clearly not
a window manager bug.

The steps to reproduce are the same under any window manager: Use "winamp mode" and make the audicious window a narrow bar then hide it and

make it re-appear using the status icon - and the window is placed where the window manager places new windows, not where it was. The window is

placed in the upper left corner in kwin, not dead center like in xfwm4, once the bug is triggered. Regardless, it seems like the window manager

"looses track" of audacious once it has been made into a narrow bar --- once.

#4 - March 26, 2020 05:37 - John Lindgren

- Status changed from New to Rejected

Not a bug. See list of common issues at https://audacious-media-player.org/problems.

#5 - March 26, 2020 09:29 - Öyvind Sæther

John, this is just laughable. Your "solution" is to.. switch window manager?

It is interesting that it didn't occur to you that this could be a common problem when I could immediately reproduce it on two different machines using

three different window managers after  Jay Philips pointed out that this is, indeed, a bug in audacious?

Perhaps you could point out a single window manager where this bug in Audacious isn't an issue? Just one? I'll add the window manager to

https://linuxreviews.org/Audacious#Winamp_mode

if I find that there is a single one where this isn't an issue.

#6 - March 26, 2020 12:45 - Jay Philips

John Lindgren wrote:

Not a bug. See list of common issues at https://audacious-media-player.org/problems.

 

It says "We've seen some of the best window managers out there hiccup on Audacious. If you've tried two or three different ones and still see the

same problem, then come and talk to us." and we are both reporting that it happens with 3 window managers and you still don't want to look into this

issue.

I reported this same issue 6 years ago when it was happening to Mate and can confirm today it also happens with the Metacity window manager as

well.

https://redmine.audacious-media-player.org/issues/385

So now its two Qt and two Gtk windows managers. Please let me know a single window manager this works correctly in.

#7 - March 26, 2020 16:13 - Jim Turner
It SEEMS to work in the AfterStep wm (the one I use), though that doesn't mean this bug is properly addressed!  AS configuration I use:

~/.afterstep/database:

Style  "*udacious"     CirculateSkip, Sticky, HonorPPosition

#8 - March 26, 2020 22:30 - Jay Philips

Installed afterstep on debian and had difficulties figuring out where the system tray icons appear, but from what i could tell, there arent any.

Jim could you record a screencast showing it working.

#9 - March 26, 2020 23:09 - John Lindgren

Works perfectly in OpenBox.

#10 - March 26, 2020 23:11 - John Lindgren

Jay Philips wrote:

It says "We've seen some of the best window managers out there hiccup on Audacious. If you've tried two or three different ones and still see

the same problem, then come and talk to us." and we are both reporting that it happens with 3 window managers and you still don't want to look

into this issue.

 

I did look into it. There is nothing we can do. We request for the window manager to place the window in a specific location. But it's only a "hint"; that's

how X11 window managers work. They are free to put the window wherever they want. The system is broken by design.

#11 - March 26, 2020 23:20 - John Lindgren

I'm mostly done with developing Audacious, by the way. It works for my needs and I have other things on which to spend my time. I'll continue to

check in here now and then, but merely to provide info that might be useful. I'm not going to revisit issues that have come up many times already and

have no fix.

If any of you think there is a fix for this "bug" on the Audacious side, then it's up to you to find it. I'm telling you there isn't, so that you don't waste your

time trying to find what others have already looked for, which isn't there. But you're welcome to look anyway. Happy hunting.

#12 - March 27, 2020 03:04 - Jay Philips

John Lindgren wrote:

Works perfectly in OpenBox.

 

Can you let me know which distro using openbox that you are using.

John Lindgren wrote:
I did look into it. There is nothing we can do. We request for the window manager to place the window in a specific location. But it's only a "hint";

that's how X11 window managers work. They are free to put the window wherever they want. The system is broken by design.

 

Okay thanks for the clarification. Can I get more information about this, as I will file a bug with the xfce window manager so they can try to fix it.

John Lindgren wrote:

If any of you think there is a fix for this "bug" on the Audacious side, then it's up to you to find it. I'm telling you there isn't, so that you don't waste

your time trying to find what others have already looked for, which isn't there. But you're welcome to look anyway. Happy hunting.

 

Can you point to where in the code this is so a possible fix can be looked into.

#13 - March 27, 2020 17:20 - Öyvind Sæther

John Lindgren wrote:

Works perfectly in OpenBox.

 

No, it doesn't. Perhaps you are confused as to when the bug triggers.

1) Start Audacious win Winamp mode

2) change it from a rectangular window to a small horizontal line or vice versa

3) minimize Audacious by clicking the system tray icon

4) Click the system tray icon to make it re-appear

5) Window doesn't appear where it was - in Openbox too.

Fedora 32 doesn't have an Afterstep package so I didn't test that one.

#14 - March 27, 2020 20:13 - John Lindgren

Öyvind Sæther wrote:

1) Start Audacious win Winamp mode

2) change it from a rectangular window to a small horizontal line or vice versa
3) minimize Audacious by clicking the system tray icon

4) Click the system tray icon to make it re-appear

5) Window doesn't appear where it was - in Openbox too.

 

That's interesting, I tried it again with those steps, this time with the old GTK+ UI, and I was able to reproduce.

With the Qt UI, it does not happen. So it could be a bug in GTK2. Good luck getting that fixed; they are working on GTK4 already.

#15 - March 27, 2020 20:19 - John Lindgren

Jay Philips wrote:

Can you point to where in the code this is so a possible fix can be looked into.

 

Point to where in the code what is?

#16 - March 27, 2020 20:26 - John Lindgren

Jay Philips wrote:

John Lindgren wrote:

I did look into it. There is nothing we can do. We request for the window manager to place the window in a specific location. But it's only a

"hint"; that's how X11 window managers work. They are free to put the window wherever they want. The system is broken by design.

 

Okay thanks for the clarification. Can I get more information about this, as I will file a bug with the xfce window manager so they can try to fix it.

 

https://developer.gnome.org/gtk2/stable/GtkWindow.html#gtk-window-move

We only call gtk_window_move() at startup though. We do not request the window to move, at all, when it is hidden and shown again via the status

icon. It is not Audacious initiating the window movement at that point. It could be GTK+ or it could be the window manager. You will have to figure that

out yourself. I am not going to investigate that for you.
#17 - March 27, 2020 21:20 - John Lindgren

Okay, definitely a bug in GTK2; it happens on Win32 as well. I added a workaround:

https://github.com/audacious-media-player/audacious-plugins/commit/6974e2cc66f5e2e56374da97be91e11878487e53

#18 - March 28, 2020 15:21 - Jay Philips

Thanks Öyvind for providing the steps. I guess I should have done audio with the video to make it clearer. Thanks John for the workaround, and hope

that it works for not just the main window, but all of the three windows (main, playlist, and equalizer).

#19 - April 03, 2020 04:28 - Jim Turner

- File MyASDesktop.png added

@Jay - You're right, AS does NOT have a "tray" and I don't use one, so can't say if it works that way or not.  In AS, it just "iconizes" to an icon on the

desktop.  Instead AS as a "Winlist" that looks sorta like the bottom of the screen in Windows (showing each window and it's title - see bottom of my

screenshot).  The key for "remembering" window placement when de-iconifying is the "HonorPPosition" ("hint" mentioned previously).  John's right

though a/b this being a GTK/Windowmanager issue.  Even though it's very old, I still really like AS as it's also lean and mean (and has the unique

dockapp swallower called Wharf! - right side of my screenshot) and I've long had it configured just the way I like it (though I had to do some

hack/coding to fix some click-2-focus annoyances (the author was a "focus-follows-mouse" guy. ;)  https://github.com/wildstar84

Regards,

Jim
